// gvgbs.h: interface for the gvgbs class and gv-graph tools.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GVGBS_H__F406D232_C4DA_11D5_A05E_BE66E6C82834__INCLUDED_)
#define AFX_GVGBS_H__F406D232_C4DA_11D5_A05E_BE66E6C82834__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//G-COLORS STANDARD

#define gBlue	11796480
#define gBluel	15728640
#define gBlued	6553600
#define gGreen	30720
#define gGreend	20480
#define gGreenl	61440
#define gRed	160
#define gRedd	120
#define gRedl	240
#define gCyan	13158400
#define gCyand	9210880
#define gCyanl	15790080
#define gMagenta	10485920
#define gMagental	15728880
#define gMagentad	6553700
#define gBrown	18060
#define gBrownl	28380
#define gBrownd	12900
#define gSeagreen	41120
#define gSeagreenl	51400
#define gSeagreend	30840
#define gYellow		61680
#define gGray	9211020
#define gGrayl	13158600
#define gGrayll	15790320
#define gGrayd	6579300
#define gGraydd	3947580



//===========GENERAL GRAPHIC FUNTIONS and Global Vars ===========

void gSetCursor(int n); //Set mouse pointer : 1:wait else Arrow

//outputs a new font for use --> after this call object should be selected
//Fat=0...10 --> thin...FAT
void gSetFont(int Height, int Fat, BOOL Italic, BOOL Orientation, CFont *F);




//=========MAIN CLASS==================

class gvgbs  
{
public:
	BOOL RoundScales;
	void Fulfil(HDC dc, RECT R);
	void GetXYticks(int *nx, int *ny, int *wx, int *wy,int *dx, int *dy);
	void SetXYticks(int nx, int ny, int wx, int wy, int dx, int dy);
	BOOL putBpixel(HDC dc, double x, double y, int rad, COLORREF col, BOOL ap);
	BOOL ShowTicks;
	BOOL ShowLabels;
	BOOL DoubleBorder;
	void SetAxis(HDC dc, double xc, double yc);
	void putline(HDC dc,double x, double y, BOOL prot);
	void SetRefPixel(double x,double y);
	void puttext(HDC dc, double x, double y, CString ss);
	void puttitle(HDC dc);
	void DrawTicks(HDC dc);
	BOOL putpixel(HDC dc, double x, double y, COLORREF col,int ap);
	BOOL gpoint(CPoint P,double *x,double *y);
	CPoint gpixel(double x , double y, BOOL areaprotection);
	void GetWorld(double *xm, double *ym, double *xM, double *yM);
	void GetScreen(int *x1,int *y1,int *x2, int *y2);
	void SetWorld(double xm,double ym,double xM,double yM);
	void SetScreen(int xtop,int ytop,int xbot,int ybot);
	void Fixing(RECT R);	
	
		//--------------------------------------------------
	RECT gbrect();
	void GetLabel(BOOL wide, BOOL top,int *x, int *y, CString *ss);
	BOOL Gvisible;
	CString Gtitle;
	CPoint refPixel;

	gvgbs();
	virtual ~gvgbs();

private:	
	void GetRinterval(double *x1,double *x2);
	double xmin;
	double xmax;
	double ymin;
	double ymax;	
	double fx;
	double fy;
	double cx;
	double cy;
	int rxleft;
	int rxright;
	int rytop;
	int rybottom;

	int nxtick;
	int nytick;
	int wytick;
	int wxtick;
	int dxtick;
	int dytick;
	
};

#endif // !defined(AFX_GVGBS_H__F406D232_C4DA_11D5_A05E_BE66E6C82834__INCLUDED_)
